; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; integer

; ---conformance---
; Sketchy Core

; ---purpose---
; Convert a natural or integer number to an integer.

; ---args---
; A - number

; ---keywords---
; INTEGER function, numbers, digit, integer, conversion

; ---see-also---
; digits, natural

; ---example---
; (integer 567) => +567

(define integer #t)

:c lib/digits.l
:c lib/normalize.l
:c lib/numbertolist.l number->list
:c lib/listtonumber.l list->number

; ---code---
(define integer (lambda (a)
	(letrec* ((int (lambda (a)
			(cond ((eq? (car a) '+) a)
				((eq? (car a) '-) a)
				(#t (cons '+ a))))))
		(list->number (int (number->list a))))))

