; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; number->list

; ---conformance---
; Sketchy Core

; ---purpose---
; Convert a number into a list of digts.

; ---args---
; X - number

; ---keywords---
; number->list function, number, list, conversion

; ---see-also---
; digits, list->number

; ---example---
; (number->list -125) => '(- 1 2 5)

(define numbertolist #t)

:c lib/digits.l

; ---code---
; Taking the CDR of a number requires relaxed typing
(define number->list (lambda (x)
	(cond ((number? x) (cdr x))
		(#t (bottom 'not 'a 'number: x)))))
