; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; symbol?

; ---conformance---
; R5RS

; ---purpose---
; Check whether an expression is a symbol.

; ---args---
; X - expression

; ---keywords---
; SYMBOL? function, atom, symbol, predicate

; ---see-also---
; boolean?, list?

; ---example---
; (symbol? 'foo) => #t

(define symbolp #t)

:c lib/booleanp.l boolean?
:c lib/not.l

; ---code---
(define symbol? (lambda (x)
	(cond ((pair? x) #f)
		((null? x) #f)
		((number? x) #f)
		((procedure? x) #f)
		((boolean? x) #f)
		(#t #t))))

